#!/usr/bin/perl

#Script used to generate SER Billing Records, it will look for the first INVITE Message and match it to a BYE Message
#that has the same CALLID

#The source file is passed as input parameter #1 and the older source file as parameter #2 so we can catch any missing INVITES 
#as a result of a log rotation. 
#NOTE: You can read directly from /var/log/messages or whatever file has the accounting records.

#Output is witten to MySQL 'cdrs' table and file '$file_res'
#MySQL Perl Module Available at:   http://search.cpan.org/author/OYAMA/Net-MySQL-0.08/MySQL.pm

#You can create the cdrs table by putting the following in a file and then feeding it to mysql like this:
#mysql -p test < "filename"
#-----------cut here--------------------
#CREATE TABLE cdrs (
#timestamp TIMESTAMP,
#start_date VARCHAR(18),
#end_date VARCHAR(18),
#caller VARCHAR(50),
#destination VARCHAR(50),
#callid VARCHAR(50),
#duration INT
#);
#--------------cut here------------------
#Written by:  Ricardo Villa  (ricvil@epm.net.co)
use Net::MySQL;

$file_src=$ARGV[0];      #Active source or SYSLOG file  
$file_src_previous=$ARGV[1];   #Previous source or SYSLOG file 
$file_temp="> /tmp/temp_bill.txt";   #Temp Files 
$file_temp1="> /tmp/temp_bill1.txt";    
$file_tempro="/tmp/temp_bill.txt";    
$file_tempro1="/tmp/temp_bill1.txt";    
$file_res=">> /opt/cdrs/processed_cdrs.txt";   #Output File 

#Open MySQL Database
my $mysql = Net::MySQL->new(
      hostname => 'localhost',   # Default use UNIX socket
      database => 'telesip',
      user     => 'ser',
      password => 'heslo'
  );

#Process the INPUT file
&input_processing($file_src,$file_temp);

#Match BYE to INVITE
open(OUT,$file_tempro);    #Open file which has SPACE separated Fields
open(RESFINAL,$file_res);
    while (<OUT>)
                {
                $bye=0; 
                $line="$_";
                ($a2, $b2, $c2, $d2, $e2, $f2, $callid2) = split(/ /); 
                chop($callid2);
                if ($d2 =~ m/BYE/)  {  #Now that we found a BYE lets try to match it to a INVITE  
                                      $bye=1; 
                                      &bye_invite_match($file_tempro);
                                      if ($bye==1) {  #If unable to find a matching INVITE then open the previous file and look there
                                                   print "WARNING:  Unable to match BYE - INVITE..checking older file..  callid=$callid2\n";
                                                   &input_processing($file_src_previous,$file_temp1); 
                                                   &bye_invite_match($file_tempro1);
                                                   if ($bye==1) {print "CRITICAL:   Unable to match BYE - INVITE !!! callid=$callid2\n"};
                                                   }
                                    }
                 }
close(RESFINAL);
close(OUT);
system ("rm /tmp/temp_bill.txt");
$mysql->close;
exit;
###----------------------------------------------------------------------------------------------------
### Subroutines

sub input_processing {

                     open(OUTIP,$_[0]);
                     open(RES,$_[1]);
                          while (<OUTIP>)
                                      {
                                      $line="$_";
                                      chop($line);
                                      ($a, $b, $c, $d, $e, $f, $g, $h, $i, $j, $k, $l, $m) = split(/ /);
                                      if ($b==" ") {($a, $blank, $b, $c, $d, $e, $f, $g, $h, $i, $j, $k, $l, $m) = split(/ /)}; #Catch extra space when day is 1-9
                                      ($a_dest, $b_dest, $c_dest, $d_orig) = split(/sip:/);
                                      ($a_dest) = split(/@/,$c_dest);   #Isolate the Destination of the Call 
                                      ($a_orig) = split(/@/,$d_orig);   #Isolate the Originator of the Call 
                                      #print (RES "$a $b $c $i caller=$a_orig destination=$a_dest $m\n"); #Output by SPACE separated Fields
                                      print (RES "$a $b $c $i $a_orig $a_dest $m\n"); #Output by SPACE separated Fields
                                      }
                     close(RES);
                     close(OUTIP);
                      }

sub bye_invite_match {
                     open(OUT1,$_[0]);  #Open the processed file for BYE - INVITE match
                         while(<OUT1>)
                         {
                         $line2="$_";
                         ($a, $b, $c, $d, $caller, $destination, $callid1) = split(/ /);
                         chop($callid1);
                         if (($d =~ m/INVITE/ | $d =~ m/CANCEL/) && ($callid1 eq $callid2)){
                                                   &callid_chk;      #Call Subroutine to Check if this INVITE is repeated
                                                   $bye=0; 
                                                   }
                         }
                     close(OUT1);
                     }


sub callid_chk {
               foreach (@callid_array) {
                                       if ($_ =~ m/$callid1/| $d =~ m/CANCEL/) {   #Check to see if INVITE callid is repeated
	                               return;  #If INVITE is repeated then exit the subroutine
                                       }
               }
               &compute_duration;      #Calculate Call Duration in Seconds
               $orig_date = "$a $b $c";
               $end_date = "$a2 $b2 $c2";
               print(RESFINAL "$orig_date $end_date $caller $destination $callid1 duration=$call_duration\n");
               $database_insert = "INSERT INTO cdrs (start_date, end_date, caller, destination, callid, duration) VALUES ('$orig_date', '$end_date', '$caller', '$destination', '$callid1', $call_duration);";

#Now Insert the Call Detail record into the Database
               $mysql->query(
                             $database_insert
                            ); 
               $callid_array[$call]=$callid1;  #Store callid in array so we now when an INVITE is repeated
               $call++;
               }
sub compute_duration {    #This subroutine converts to seconds the date from the start of the month 
              $orig_day=$b;
              $end_day=$b2;
              if ($orig_day > $end_day) {$orig_day=0}; #if a call rolls over from one month to the next then detect it
              ($orig_hour,$orig_minute,$orig_second)=split(/:/,$c); 	  
              $orig_absolute=($orig_day*24*60*60)+($orig_hour*60*60)+($orig_minute*60)+$orig_second;  #Start time in seconds
              ($end_hour,$end_minute,$end_second)=split(/:/,$c2); 	  
              $end_absolute=($end_day*24*60*60)+($end_hour*60*60)+($end_minute*60)+$end_second;       #End time in seconds
              $call_duration=$end_absolute-$orig_absolute;             #Compute call duration
              }
